#include <iostream>
#include <vector>

using namespace std;


struct Input {
    vector<double> numbers;
    size_t bin_count{};
    size_t number_count{};
    size_t max_count{};
};

Input
input_data() {
    Input in;
    cerr << "Enter number count: ";
    cin >> in.number_count;


    vector<double> numbers(in.number_count);
    in.numbers.resize(in.number_count);
    for (size_t i = 0; i < in.number_count; i++) {
        cin >> in.numbers[i];
    }

    size_t bin_count;
    cerr << "Enter bin count: ";
    cin >> in.bin_count;

    size_t max_count;
    in.max_count = 0;
    return in;
}

void
find_minmax(const vector<double>& numbers, double& min, double& max) {
    min = numbers[0];
    max = numbers[0];
    for (double x : numbers)
    {
        if (x < min){
            min = x;
        }
        else if (x > max){
            max = x;
        }
    }
}

vector <size_t>
make_histogram(const vector<double>& numbers, size_t & bin_count, size_t & number_count, size_t & max_count) {
    double min, max;
    find_minmax(numbers, min, max);
    double bin_size = (max - min) / bin_count;
    vector<size_t> bins(bin_count);
    max_count = bins[0];
    for (size_t i = 0; i < number_count; i++){
        bool found = false;
        for (size_t j = 0; (j < bin_count - 1) && !found; j++){
            auto lo = min + j * bin_size;
            auto hi = min + (j + 1) * bin_size;
            if ((lo <= numbers[i]) && (numbers[i] < hi)){
                bins[j]++;
                found = true;
            }
            if (bins[j] > max_count){
                max_count = bins[j];
            }
        }
        if (!found){
            bins[bin_count - 1]++;
        }
        if (bins[bin_count - 1] > max_count){
            max_count = bins[bin_count - 1];
        }
    }
    return bins;
}

void
show_histogram_text(vector<size_t>& bins, size_t & max_count,size_t & bin_count){
const size_t SCREEN_WIDTH = 80;
const size_t MAX_ASTERISK = SCREEN_WIDTH - 3 - 1;
if (max_count > MAX_ASTERISK){
        vector<size_t> hights(bin_count);
        for (size_t i = 0; i < bin_count; i++){
            size_t height = MAX_ASTERISK * (static_cast<double>(bins[i]) / max_count);
            hights[i] = height;
        }

        for (size_t i = 0; i < bin_count; i++){
            printf("%3d|", bins[i]);
            for (size_t j = 0; j < hights[i]; j++){
                cout<<"*";
            }
            cout << endl;
        }
    }
    else{
        for (size_t i = 0; i < bin_count; i++)
        {
            printf("%3d|", bins[i]);
            for (size_t j = 0; j < bins[i]; j++){
                cout<<"*";
            }
            cout << endl;
        }
    }

}
int main()
{
    auto in = input_data();
    auto bins = make_histogram(in.numbers, in.bin_count, in.number_count, in.max_count);
    show_histogram_text(bins, in.max_count, in.bin_count);
}
